#include "stdafx.h"
#include "ewCtrl1.h"
using namespace ki;
using namespace editwing;



//-------------------------------------------------------------------------
// EwEditRg[쐬/j
//-------------------------------------------------------------------------

EwEdit::ClsName EwEdit::className_ = TEXT("EditWing Control-01");

EwEdit::EwEdit()
	: WndImpl( className_, WS_CHILD|WS_VISIBLE, WS_EX_CLIENTEDGE )
{
	static bool ClassRegistered = false;
	if( !ClassRegistered )
	{
		ClassRegistered = true;

		// \ẑ݁ANXo^s
		WNDCLASSEX wc    = {0};
		wc.lpszClassName = className_;
		WndImpl::Register( &wc );
	}
}

EwEdit::~EwEdit()
{
	Destroy();
}

void EwEdit::on_create( CREATESTRUCT* cs )
{
	doc_  = new doc::Document;
	view_ = new view::View( *doc_, hwnd() );
}

void EwEdit::on_destroy()
{
	view_ = NULL;
	doc_  = NULL;
}



//-------------------------------------------------------------------------
// ȒPȃbZ[W
//-------------------------------------------------------------------------

LRESULT EwEdit::on_message( UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg == WM_SETFOCUS )
	{
		view_->SetFocus();
		return 0;
	}
	else if( msg == WM_SIZE )
	{
		RECT rc;
		getClientRect( &rc );
		view_->MoveTo( 0, 0, rc.right, rc.bottom );
		return 0;
	}

	return WndImpl::on_message( msg, wp, lp );
}
